"use strict";
this.name        = "carriers";
this.author      = "Norby";
this.copyright   = "2014 Norbert Nagy";
this.licence     = "CC BY-NC-SA 4.0";
this.description = "Carriers with open decks.";
this.version     = "0.2";

//customizable properties
/*
this.$CarriersMaxFuelReserve = 50; //in light years
this.$CarriersFuelCost = 3; //credits for each light year fuel
this.$CarriersReFuelDistance = 5000; //m far from the main station
*/

//internal properties, should not touch
//this.$CarriersFuelReserve = 0;
this.$CarriersPirate = null; //store a created pirate carrier
this.$CarriersShip = null; //store the created trader ship to prevent recreates
this.$CarriersSH = null; //store a pointer to Ship_Storage_Helper.js
this.$CarriersTimer = null;

//world script events
this.startUp = function() {
/*	this.$CarriersFuelReserve = missionVariables.$CarriersFuelReserve;
	if( !this.$CarriersFuelReserve ) this.$CarriersFuelReserve = this.$CarriersMaxFuelReserve;
	this.$CarriersSoundRefuel = new SoundSource;
	this.$CarriersSoundRefuel.sound = "buy.ogg"; //refuel sound
	this.$CarriersSoundRefuel.loop = false;
	this.$CarriersSoundRefuel.repeatCount = 1;	
*/	this.$CarriersTimer = new Timer(this, this.$Carriers_Timed.bind(this), 2, 2);
	this.$CarriersSH = worldScripts["Ship_Storage_Helper.js"];
	if(!this.$CarriersSH) log("Carriers", "Error: Carriers can not change ship without Ship Storage Helper OXP");
//	this.$Carriers_AwardCarrier();//for making savegames only
}

this.playerWillSaveGame = function(message) {
//        missionVariables.$CarriersFuelReserve = this.$CarriersFuelReserve;
}

//Carriers functions
this.$Carriers_Timed = function() {
	var m = system.mainStation;
	if( m && m.isValid && ( !this.$CarriersShip || !this.$CarriersShip.isValid ) ) { //delayed create
		if( system.government < 5 )
			this.$CarriersPirate = system.addShipsToRoute("carriers-pirate", 1, Math.random(), "wp")[0];
		this.$CarriersShip = system.addShips("carriers-trader", 1, m.position, 25000)[0];
//		this.$CarriersShip.setAI("nullAI.plist");//debug
	}

}

this.$Carriers_AwardCarrier = function() { //player will start in a Carrier for making savegames

	this.$Carriers_PlayerShipEqs = []; //save equipments for transfer all of them into the new ship
	this.$Carriers_PlayerShipEqDmg = []; //store equipment damage status
	var i=-1;//index in the old eq array
	var p=-1;//index in the new eq array
	var eq = player.ship.equipment; //local variable, faster
	while(eq[++i]) {
		if( eq[i].name.length > 0 ) {
			if( this.$Carriers_Debug )
				log("Carriers", "i:"+i+" name:"+eq[i].name);
			this.$Carriers_PlayerShipEqs[++p] = eq[i];
			if(player.ship.equipmentStatus(eq[i].equipmentKey) ==="EQUIPMENT_DAMAGED")
				this.$Carriers_PlayerShipEqDmg[p] = true;
			else this.$Carriers_PlayerShipEqDmg[p] = false;
		} else {//skip noname eqs awarded by NumericHUD to avoid timeLimit error
			for( var j = i + 10; j < eq.length; j+=10 ) {
				if( eq[j].name.length != 0 ) {
					i = j - 10; //end of skip
					j = eq.length;
				}
			}
			while( i < eq.length && eq[i].name.length == 0 ) i++;
			i--;
		}
	}

//	player.replaceShip("anaconda-carrier-player", 0);
//	player.replaceShip("cobra1-carrier-player", 0);
//	player.replaceShip("cobra3-carrier-player", 0);
//	player.replaceShip("ferdelance-carrier-player", 0);
	
	
	var i=-1; //give back equipments
	var eq = player.ship.equipment; //local variable, faster
	while(eq[++i]) {
		if( eq[i].name.length > 0 ) {
			player.ship.removeEquipment(eq[i].equipmentKey);
		} else {//skip noname eqs awarded by NumericHUD to avoid timeLimit error
			for( var j = i + 10; j < eq.length; j+=10 ) {
				if( eq[j].name.length != 0 ) {
					i = j - 10; //end of skip
					j = eq.length;
				}
			}
			while( i < eq.length && eq[i].name.length == 0 ) i++;
			i--;
		}
	}
	i=-1;
	while(this.$Carriers_PlayerShipEqs[++i]) {
		player.ship.awardEquipment(this.$Carriers_PlayerShipEqs[i]);
		if(this.$Carriers_PlayerShipEqDmg[i])
			player.ship.setEquipmentStatus(
				this.$Carriers_PlayerShipEqs[i],
				"EQUIPMENT_DAMAGED");
	}
	
}


this.$Carriers_StoreShip = function() {
	var sh = this.$CarriersSH;
	if( sh ) {
		var storedShipString = sh.storeCurrentShip();
		sh.disableVortexPBNSFunc("delete");
		sh.disableMaelstromPBNSFunc("delete");
		sh.disableTCATPBNSFunc();
		return(storedShipString);
	} else log("Carriers", "Error: Carriers can not store ship without Ship Storage Helper OXP");
}

this.$Carriers_RestoreShip = function(storedShipString) {
	if(this.$CarriersSH) {
		this.$CarriersSH.restoreStoredShip(storedShipString);
	} else log("Carriers", "Error: Carriers can not restore ship without Ship Storage Helper OXP");
}
